#ifndef _EEPROM52_H_
#define _EEPROM52_H_
uchar a_a;

/********STC89C51ֲ*******
һ1000H--11FF
ڶ1200H--13FF
1400H--15FF
1600H--17FF
1800H--19FF
1A00H--1BFF
1C00H--1DFF
ڰ1E00H--1FFF
*****************/

/********STC89C52ֲ*******
һ2000H--21FF
ڶ2200H--23FF
2400H--25FF
2600H--27FF
2800H--29FF
2A00H--2BFF
2C00H--2DFF
ڰ2E00H--2FFF
*****************/


#define RdCommand 0x01 //ISPĲ
#define PrgCommand 0x02
#define EraseCommand 0x03 
#define Error 1
#define Ok 0
#define WaitTime 0x01 //CPUĵȴʱ
sfr ISP_DATA=0xe2;  //Ĵ
sfr ISP_ADDRH=0xe3;
sfr ISP_ADDRL=0xe4;
sfr ISP_CMD=0xe5;
sfr ISP_TRIG=0xe6;
sfr ISP_CONTR=0xe7;

/* ================  ISP,IAP  ================= */
void ISP_IAP_enable(void)
{
	 EA = 0;       /* ж   */
	 ISP_CONTR = ISP_CONTR & 0x18;       /* 0001,1000 */
	 ISP_CONTR = ISP_CONTR | WaitTime; /* дӲʱ */
	 ISP_CONTR = ISP_CONTR | 0x80;       /* ISPEN=1  */
}
/* =============== ر ISP,IAP  ================== */
void ISP_IAP_disable(void)
{
	 ISP_CONTR = ISP_CONTR & 0x7f; /* ISPEN = 0 */
	 ISP_TRIG = 0x00;
	 EA   =   1;   /* ж */
}
/* ================ õĴ ==================== */
void ISPgoon(void)
{
	 ISP_IAP_enable();   /*  ISP,IAP  */
	 ISP_TRIG = 0x46;  /* ISP_IAPֽ1 */
	 ISP_TRIG = 0xb9;  /* ISP_IAPֽ2 */
	 _nop_();
}
/* ==================== ֽڶ ======================== */
unsigned char byte_read(unsigned int byte_addr)
{
	EA = 0;
	 ISP_ADDRH = (unsigned char)(byte_addr >> 8);/* ֵַ */
	 ISP_ADDRL = (unsigned char)(byte_addr & 0x00ff);
	 ISP_CMD   = ISP_CMD & 0xf8;   /* 3λ  */
	 ISP_CMD   = ISP_CMD | RdCommand; /* д */
	 ISPgoon();       /* ִ  */
	 ISP_IAP_disable();    /* رISP,IAP */
	 EA  = 1;
	 return (ISP_DATA);    /* ض */
}
/* ==================  ======================== */
void SectorErase(unsigned int sector_addr)
{
	 unsigned int iSectorAddr;
	 iSectorAddr = (sector_addr & 0xfe00); /* ȡַ */
	 ISP_ADDRH = (unsigned char)(iSectorAddr >> 8);
	 ISP_ADDRL = 0x00;
	 ISP_CMD = ISP_CMD & 0xf8;   /* յ3λ  */
	 ISP_CMD = ISP_CMD | EraseCommand; /* 3  */
	 ISPgoon();       /* ִ  */
	 ISP_IAP_disable();    /* رISP,IAP */
}
/* ==================== ֽд ======================== */
void byte_write(unsigned int byte_addr, unsigned char original_data)
{
	 EA  = 0;
//	 SectorErase(byte_addr);
	 ISP_ADDRH = (unsigned char)(byte_addr >> 8);  /* ȡַ  */
	 ISP_ADDRL = (unsigned char)(byte_addr & 0x00ff);
	 ISP_CMD  = ISP_CMD & 0xf8;    /* 3λ */
	 ISP_CMD  = ISP_CMD | PrgCommand;  /* д2 */
	 ISP_DATA = original_data;   /* д׼ */
	 ISPgoon();       /* ִ  */
	 ISP_IAP_disable();     /* رIAP */
	 EA =1;
}


		


#endif